package robocup;

import Protobuf.MessagesRobocupSslWrapper.SSL_WrapperPacket;
import com.google.protobuf.InvalidProtocolBufferException;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.net.UnknownHostException;
import java.util.Arrays;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;
import sun.awt.windows.ThemeReader;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;
/**
 * This class is an example of following the ball with the received messages by SSLVision.
 * @author David Saldana
 */
public class Referee  {

   private static final String IP_SERVER = "224.5.23.25";
   private static final int PORT = 10020;
   private int goles_amarillo = 0;
   private int goles_azul = 0;
   private Timer time;
   private NewJFrame frame;
   private MulticastSocket s;
   private byte[] buf;
   private DatagramPacket recv;
   private SSL_WrapperPacket parsEFrom;
   private float buf_pelota[] = {0 , 0};
   private float buf_azul[] = {0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0};
   private float buf_amarillo[] = {0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0};
   private float pelota[]={0,0};
   private float azul[]={0,0,0,0,0,0,0,0,0,0};
   private float amarillo[]={0,0,0,0,0,0,0,0,0,0};
   private int contador = 0;
   private InetAddress group;
   private int bandera = 1;
   private float aux1,aux2;
   private int tercero = 0;
   
   
   
   public Referee(NewJFrame fr) throws UnknownHostException, IOException, InterruptedException{
    frame = fr;    
    time = new Timer(10,new ActionListenerImpl()); //en el this va un accion listener 
    group = InetAddress.getByName(IP_SERVER);
    s = new MulticastSocket(PORT);
    s.joinGroup(group);
            // Define an udp packet to receive.
    buf = new byte[1000];
    recv = new DatagramPacket(buf, buf.length);
 
    }  
   // public void goal 
   // public void ball_outofbounds
   // public void Intruder_robot
   // public robot Crash ... aun no se sabe si se va a implementar
   // public void set_scoreboard
   // public array get_scoreboard
   // public void start_match
   // public void stop_match
   // public void total_match_time  aqui se pide saber si ha finalizado el primer tiempo
   // public void penalty_cards
   // public void free_kick
   // public void indirect_kick
    
    
    // equipo true es yellow y false es blue
// equipo true es yellow y false es blue
   public int getGolazul(){
       return goles_azul;
   }
   
   public int getGolamarillo(){
       return goles_amarillo;
   }
   

   public void EsGol(){
	float x=pelota[0]; 
	float y=pelota[1];
	//limites arco yellow anota:         Blue anota en:
	// x1= -3000 x2=-3150          x1=3000   x2=3150 
	// y1= 350   y2=-350           y1=350    y2=-350
        if(bandera == 1){
	if(y<350 && y>-350){
		if(x<-3000 && x>-3214){
				goles_amarillo++;
                                System.out.println("gool amarillo\n");
                                bandera = 0;
                                aux1 = x;
                                aux2 = y;
                                frame.setTextam();
                                time.stop();
                                
		}
                else if(x>3000 && x<3214){
				goles_azul++;
                                System.out.println("gool azul\n");
                                bandera = 0;
                                aux1 = x;
                                aux2 = y;
                                frame.setTextaz();
                                time.stop();
                }
        }
        }
        else{
            if(aux1 != x || aux2 !=y) bandera = 1;
        }
}

    
    
    public boolean Intruso(){
	float x;
	float y;
	

		for(int i=0; i<9 ; i=i+2){
				x=azul[i];
				y=azul[i+1];
				
				//limites de Area Blue del intruso          Area Yellow del intruso
				// Rectangulo de al medio                   
				// x1= -3000  x2= -2250                     x1=3000   x2=2250
				// y1= 175    y2= -175                      y1=175    y2=-175
	
				//CIRCULOS  R=800
				// Blue arriba		Blue abajo		Yellow arriba		Yellow abajo
				// x0= -3000		-3000			3000				3000
				// y0= 175			-175			175					-175
	
				if((x>-3000 && x<-2250) || (x>2250 && x<3000)){
					if(y<175 && y>-175){
                  
						return true;
					}	
				}
				// x=3000 y y=-175
				if(((x-3000)*(x-3000))+((y+175)*(y+175))<640000){
					if(x<3000 && y<-175){
                
						return true;
					}
				}
				if(((x-3000)*(x-3000))+((y-175)*(y-175))<640000){
					if(x<3000 && y>175){
                 
						return true;
					}
				}
				if(((x+3000)*(x+3000))+((y-175)*(y-175))<640000){
					if(x>-3000 && y>175){
                
						return true;
					}
				}
				if(((x+3000)*(x+3000))+((y+175)*(y+175))<640000){
					if(x>-3000 && y<-175){
                  
						return true;
					}
				}
                                
			
		}	
	
	
		for(int i=0; i<9 ; i=i+2){
			        x=amarillo[i];
				y=amarillo[i+1];
				
				//limites de Area Blue del intruso          Area Yellow del intruso
				// Rectangulo de al medio                   
				// x1= -3000  x2= -2250                     x1=3000   x2=2250
				// y1= 175    y2= -175                      y1=175    y2=-175
	
				//CIRCULOS  R=800
				// Blue arriba		Blue abajo		Yellow arriba		Yellow abajo
				// x0= -3000		-3000			3000				3000
				// y0= 175			-175			175					-175
	
				if((x>-3000 && x<-2250) || (x>2250 && x<3000)){
					if(y<175 && y>-175){
                 
						return true;
					}	
				}
				// x=3000 y y=-175
				if(((x-3000)*(x-3000))+((y+175)*(y+175))<640000){
					if(x<3000 && y<-175){
                  
						return true;
					}
				}
				if(((x-3000)*(x-3000))+((y-175)*(y-175))<640000){
					if(x<3000 && y>175){
                  				return true;
					}
				}
				if(((x+3000)*(x+3000))+((y-175)*(y-175))<640000){
					if(x>-3000 && y>175){
                  
						return true;
					}
				}
				if(((x+3000)*(x+3000))+((y+175)*(y+175))<640000){
					if(x>-3000 && y<-175){
                  
						return true;
					}
				}
			
		}
	
	return false;	
}	
    
public boolean Fuera(){
float x=pelota[0];
float y=pelota[1];

// Pelota fuera del area
// x1= 3000		y1=2000
// x2= -3000	y2=-2000

	if( (y>2000) || (y<-2000) || ((x<-3000)&&(y>350)) || ((x<-3000)&&(y<-350)) || ((x>3000)&&(y>350)) || ((x>3000)&&(y<-350)) ){
		return true;
	}
      return false;
}

public void start(){
    time.start();
}

public void stop(){
    time.stop();
}

    class ActionListenerImpl implements ActionListener {

        public ActionListenerImpl() {
        }
        @Override
        public void actionPerformed(ActionEvent e) {
            try {
                s.receive(recv);
            } catch (IOException ex) {
                Logger.getLogger(Referee.class.getName()).log(Level.SEVERE, null, ex);
            }
            byte[] a = new byte[recv.getLength()];
            System.arraycopy(buf, 0, a, 0, recv.getLength());
            try {
                // Parse the received message
            parsEFrom = SSL_WrapperPacket.parseFrom(a);
            } catch (InvalidProtocolBufferException ex) {
                Logger.getLogger(Referee.class.getName()).log(Level.SEVERE, null, ex);
            }
            pelota[0]= parsEFrom.getDetection().getBalls(0).getX();
            pelota[1]= parsEFrom.getDetection().getBalls(0).getY();
            int i = 0;
            for(int x=0; x<5;x++){
                azul[i] = parsEFrom.getDetection().getRobotsBlue(x).getX();
                i++;
                azul[i] = parsEFrom.getDetection().getRobotsBlue(x).getY();
            }
            
            parsEFrom.getDetection().getTCapture();

            i = 0;
            for(int x=0; x<5;x++){
                amarillo[i] = parsEFrom.getDetection().getRobotsYellow(x).getX();
                i++;
                amarillo[i] = parsEFrom.getDetection().getRobotsYellow(x).getY();
                System.out.println(amarillo[i-1]+","+amarillo[i]);
            }
            
                                
                
          
            buf_pelota = pelota;
            
            if(Fuera()){
                System.out.print("La pelota esta fuera");
            }

            if(!Arrays.equals(buf_azul,azul)){
                System.out.println("Equipo Azul: \n Robot 1: ("+azul[0]+" , "+azul[1]+")\n Robot 2: ("+azul[2]+" , "+azul[3]+"\n Robot 3: ("+azul[4]+" , "+azul[5]+")\n Robot 4: ("+azul[6]+" , "+azul[7]+")\n Robot 5: ("+azul[8]+" , "+azul[9]+")");
            }
            buf_azul = azul;

            if(!Arrays.equals(buf_amarillo,amarillo)){
                System.out.println("Equipo Amarillo: \n Robot 1: ("+amarillo[0]+" , "+amarillo[1]+")\n Robot 2: ("+amarillo[2]+" , "+amarillo[3]+"\n Robot 3: ("+amarillo[4]+" , "+amarillo[5]+")\n Robot 4: ("+amarillo[6]+" , "+amarillo[7]+")\n Robot 5: ("+amarillo[8]+" , "+amarillo[9]+")");
            }
            buf_amarillo = amarillo;
            contador +=10;
            if(contador==500){
                contador=0;
                frame.tiempo();
                
            }

        }
        }

}
   
      
        
